﻿using System.Threading.Tasks;
using UnityEngine;

public class DSharkMod : Mod
{
	static DSharkMod instance;
	static int sharkDelay = 60000;
	int sharkChance = 30;
	int sharkDmg;

	private void Start()
	{
		instance = this;
		Debug.Log("DShark has been loaded!");
	}
	public void SetSharkDelay(string[] args)
	{
		int inputDelay;
		int.TryParse(args[0], out inputDelay);
		if (args.Length == 1 && inputDelay >= 0 && inputDelay <= 600000)
		{
			sharkDelay = inputDelay;
			Debug.Log("<color=#3498db>[info]</color>\tDelay to spawn more sharks changed to: " + inputDelay + "ms");
		}
		else if (args.Length == 0)
		{
			Debug.Log("\tSet temporary new delay: <i>dsdelay (0-600000)</i> [default:60000]");
		}
		else
		{
			Debug.LogError("<color=#e74c3c>[error]</color>\tUsage: dsdelay (0-600000)");
		}
	}
	public void SetSharkChance(string[] args)
	{
		int inputChance;
		int.TryParse(args[0], out inputChance);
		if (args.Length == 1 && inputChance >= 0 && inputChance <= 100)
		{
			sharkChance = inputChance;
			Debug.Log("<color=#3498db>[info]</color>\tChance to spawn more sharks changed to: " + inputChance + "%");
		}
		else if (args.Length == 0)
		{
			Debug.Log("\tSet temporary new chance: <i>dschance (0-100)</i> [default:30]");
		}
		else
		{
			Debug.LogError("<color=#e74c3c>[error]</color>\tUsage: dschance (0-100)");
		}
	}

	public override void WorldEvent_WorldLoaded()
	{
		string gmode = GameModeValueManager.GetCurrentGameModeValue().gameMode.ToString();
		if (gmode == "Hardcore") { sharkDmg = 36; }
		else if (gmode == "Normal") { sharkDmg = 30; }
		else if (gmode == "Easy") { sharkDmg = 21; }
		else { sharkDmg = 36; }
		Debug.Log("GameMode: " + gmode + "(SharkDamage: " + sharkDmg + ")");
		return;
	}

	public override void LocalPlayerEvent_Hurt(float damage, Vector3 hitPoint, Vector3 hitNormal, EntityType damageInflictorEntityType)
	{
		if (!Semih_Network.IsHost)
		{
			FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.normal, "You are not the host!", 3, HNotify.ErrorSprite);
			return;
		}
		if (damage == sharkDmg && damageInflictorEntityType == EntityType.Enemy && sharkChance != 0)
		{
			int sharkDice = UnityEngine.Random.Range(1, 100);
			if (sharkDice <= sharkChance)
			{
				AddShark();
				Debug.Log("SpawnSuccess: Dice (" + sharkDice + ")");
			}
			else
			{
				Debug.Log("SpawnFail: Dice (" + sharkDice + ")");
			}
		}
	}

	public async static void AddShark()
	{
		Debug.Log("Starting Delay: " + sharkDelay + "ms");
		await Task.Delay(sharkDelay);
		AI_NetworkBehaviour spawned = ComponentManager<Network_Host_Entities>.Value.CreateAINetworkBehaviour(AI_NetworkBehaviourType.Shark, RAPI.GetLocalPlayer().transform.position + RAPI.GetLocalPlayer().transform.forward * 90);
	}
	public void OnModUnload()
	{
		Debug.Log("DShark has been unloaded!");
	}

	[ConsoleCommand(name: "dschance", docs: "Change your DShark spawn chance.")]
	public static void dschanceCommand(string[] args)
	{
		instance.SetSharkChance(args);
	}

	[ConsoleCommand(name: "dsdelay", docs: "Change your DShark spawn delay.")]
	public static void dsdelayCommand(string[] args)
	{
		instance.SetSharkDelay(args);
	}
}